#!/bin/bash
#This script compiles the sources files in src folder. It compiles a source only when necessary : source file has been newly created or recently updated "
PRISM_HOME=`pwd` #this is the root directory of the PRISM_Projet

function info {
  echo "***Compiling sources***"
  echo "each source will be compiled only if necessary : source file has been newly created or recently updated "
}

info #call the info function

if [ ! -d $PRISM_HOME/classes ] #if the classes directory does not already exist
  then
    echo "****creating directory $PRISM_HOME/classes which will contain the generated .class files***"
    mkdir classes
fi

for f in src/*
do
    source=`basename $f`
    fname=`echo $source | awk -F"." '{print $1}'` #source name without extension
    class_file=classes/$fname.class
    if [ ! -e $class_file ]
    then
      echo "generating : $class_file "
      javac -classpath .:$PRISM_HOME/src:$PRISM_HOME/libs/*:$PRISM_HOME/libs/gnu-crypto-2.0.1-bin/lib/* -d ./classes src/$source # the parameter -d indicates the destination folder for the generated .class files
    elif [ src/$source -nt $class_file ]
    then
      echo "Updating: $class_file "
      javac -classpath .:$PRISM_HOME/src:$PRISM_HOME/libs/*:$PRISM_HOME/libs/gnu-crypto-2.0.1-bin/lib/* -d ./classes src/$source # the parameter -d indicates the destination folder for the generated .class files
    fi
done

#echo "***compiling completed***"
