import java.io.IOException; 
import org.apache.hadoop.fs.Path;         
import org.apache.hadoop.conf.*;         
import org.apache.hadoop.io.*;         
import org.apache.hadoop.io.compress.CompressionCodec;
import org.apache.hadoop.io.compress.CompressionCodecFactory;
import org.apache.hadoop.mapreduce.*;         
import org.apache.hadoop.mapreduce.lib.input.*;         
import org.apache.hadoop.mapreduce.lib.output.*;         
import org.apache.hadoop.util.*;


public class BytesInputFormat extends FileInputFormat<LongWritable,BytesWritable>{

	@Override
	  public RecordReader<LongWritable, BytesWritable> 
	    createRecordReader(InputSplit split,
	                       TaskAttemptContext context) {
	    return new BytesRecordReader();
	  }

	  @Override
	  protected boolean isSplitable(JobContext context, Path file) {
	    CompressionCodec codec = 
	      new CompressionCodecFactory(context.getConfiguration()).getCodec(file);
	    return codec == null;
	  }

}

