import org.apache.hadoop.io.IntWritable;


 /* 
 * The purpose of this class is to group all the settings for the PRISM Project, in this way
 * values are not hard coded and any modification to a parameter is much simpler and you don't have to go trough the code of a class to modify
 * it's value manually
 */
public final class PRISM_Settings {
	public final static String RIJNDAEL_DEFAULT_KEY_STRING = "allyourbasearebelongtoushahahaha"; // this is the secret key K, the length of the key must be at least the length of the computed hash (here, 32 bytes).
	public final static int RIJNDAEL_BLOCK_SIZE = 32; // 32 Bytes word length
	public final static int COUNTER_LENGTH = 2;
	public final static int RJINDAEL_KEY_SIZE = 32; // 32 bytes = 256 bits
	public final static Long EC_ELGAMAL_DEFAULT_SECRET_KEY = Long.valueOf(2048); //Elliptic Curve EL Gamal deafult secret key
	public final static int ELGAMAL_KEY_SIZE = 32; // 32 bytes , but remember : ELGAMAL generator requires the key size to be specified in terms of # bits
	public final static int ELGAMAL_BLOCK_SIZE = 2*ELGAMAL_KEY_SIZE; //bloc size in bytes - the bloc size of Elgamal is twice the key size
	public static final String utf8 = "UTF-8";
	
	public final static byte[] ZERO = new byte[]{(byte)0x0}; //This is equal to 0
	public final static byte[] ONE = new byte[]{(byte)0x1}; //This is equal to 1
	
	public final static int DEFAULT_NUMBER_OF_ROUNDS = 5;//Number of rounds
	public final static int DEFAULT_EXP_FOR_NUMBER_OF_ROWS = 10;//Number of rounds

}
