import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

import org.apache.hadoop.io.ArrayWritable;
import org.apache.hadoop.io.Writable;
import org.apache.hadoop.io.BytesWritable;
import org.apache.hadoop.io.WritableFactories;


public class BytesArrayWritable extends ArrayWritable implements Writable {
	
	private BytesWritable[] values ;
	
	public BytesArrayWritable(){
		super(BytesWritable.class);
	}
	
	public BytesArrayWritable(Class<? extends Writable> valueClass) {
		super(valueClass);
	}
	
	public BytesArrayWritable(BytesWritable[] values){ 
		super(BytesWritable.class);
		this.values = values;
	}
	
	public BytesWritable[] getAll() { return this.values; }
	
	@Override
	public Class getValueClass() {
	    return BytesWritable.class;
	  }


	@Override
	public void write(DataOutput out) throws IOException {
	    out.writeInt(this.values.length);                 
	    for (int i = 0; i < this.values.length; i++) {
		byte[] b = this.values[i].getBytes();
		int l = b.length;	
		out.writeInt(l);
		out.write(b);
	    }
	}
	
	@Override
	public void readFields(DataInput in) throws IOException {
	    this.values = new BytesWritable[in.readInt()];          
	    for (int i = 0; i < this.values.length; i++) {
		int l = in.readInt();
		byte b[] = new byte[l];
		in.readFully(b);
		values[i] = new BytesWritable(b);
	    }
	  }
}
